// Demo 20: AimPractice.java
//
//   Simple Java GunSight Aiming Applet
//   Uses GunSight class, illustrates using objects
//   from a separate class we have written
//
//   Copyright 1999 by Charles W. Neville

import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import GunSight;

public class AimPractice
  extends Applet implements ActionListener {

  TextField vertical, horizontal;
  Label verticalLabel, horizontalLabel;
  Button fire;
  GunSight sight;

  boolean firePressed = false;

  // build Applet Panel
  public void init() {

     verticalLabel   = new Label("Vertical Coords ");
     add(verticalLabel);
     vertical = new TextField(5);
     vertical.setText("150");
     vertical.addActionListener(this);
     add(vertical);

     horizontalLabel = new Label("Horizontal Coords ");
     add(horizontalLabel);
     horizontal = new TextField(5);
     horizontal.setText("200");
     horizontal.addActionListener(this);
     add(horizontal);

     fire = new Button("Fire");
     fire.addActionListener(this);
     add(fire);

     // call the Constructor for our GunSight class
     sight = new GunSight();

   } // init

   // draw sight and maybe laser cannon tracer line
   public void paint(Graphics g) {

      g.setColor(Color.black);

      sight.drawSight(g);

      if(firePressed) {
        fireLaserCannon(g);
        firePressed = false;
      }

   } // paint

   // fire laser cannon by drawing cannon tracer line,
   // sorry, no sound effects in deep space!
   void fireLaserCannon(Graphics g) {

      int x, y;

      x = sight.getX();  y = sight.getY();
      g.setColor(Color.red);
      g.drawLine(200, 350, x, y);  // cannon tracer line
      g.setColor(Color.black);
   }
      
   // handle action events
   public void actionPerformed(ActionEvent e) {

      // use object identity to decide which object
      // generated ActionEvent, and take appropriate
      // action
      if(e.getSource() == vertical) {
         sight.setY(Integer.parseInt(vertical.getText()));
      }
      else if(e.getSource() == horizontal) {
         sight.setX(Integer.parseInt(horizontal.getText()));
      }
      else if(e.getSource() == fire) {
         firePressed = true;
      }
   
      repaint();

   } // actionPerformed

} // class AimPractice
